SystemOrganization addCategory: #'Seaside-Tests-JSON'!

TestCase subclass: #WAJsonRenderingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-JSON'!

!WAJsonRenderingTest methodsFor: 'private' stamp: 'pmm 1/22/2012 16:24'!
assert: aBlock gives: aString
	| json |
	json := String streamContents: [ :stream |
		| context document canvas |
		document := WAJsonDocument on: stream.
		context := WARenderContext new
			actionUrl: WAUrl new;
			document: document;
			yourself.
		 canvas := WAJsonCanvas context: context.
		canvas render: aBlock.
		document close ].
	self
		assert: json = aString
		description:	'Expected: ' , aString printString , ', Actual: ', json printString
		resumable: true! !

!WAJsonRenderingTest methodsFor: 'testing' stamp: 'pmm 8/24/2011 11:46'!
testArray
	self
		assert: [ :json |
			json array: [
				json
					value: 1;
					value: '1';
					value: true;
					value: nil ] ]
		gives: '[1, "1", true, null]'.
	self
		assert: [ :json |
			json array: [
				json value: 1 ] ]
		gives: '[1]'! !

!WAJsonRenderingTest methodsFor: 'testing' stamp: 'pmm 8/24/2011 12:03'!
testNestedArray
	self
		assert: [ :json |
			json array: [
				json
					value: 1;
					value: [
						json array: [
							json value: '1' ] ];
					value: 2 ] ]
		gives: '[1, ["1"], 2]'.
	self
		assert: [ :json |
			json array: [
				json array: [
					json value: 1 ] ] ] 
		gives: '[[1]]'! !

!WAJsonRenderingTest methodsFor: 'testing' stamp: 'pmm 8/24/2011 12:06'!
testNestedObject
	self
		assert: [ :json |
			json object: [
				json
					key: 'a' value: 'b';
					key: '1' value: [
						json object: [
							json key: '2' value: 2 ] ];
					key: 'c' value: 'd' ] ]
		gives: '{"a": "b", "1": {"2": 2}, "c": "d"}'! !

!WAJsonRenderingTest methodsFor: 'testing' stamp: 'pmm 8/24/2011 13:58'!
testObject
	self
		assert: [ :json |
			json object: [
				json
					key: '1' value: '1';
					key: '2' value: 2 ] ]
		gives: '{"1": "1", "2": 2}'.
	self
		assert: [ :json |
			json object: [
				json key: '1' value: 1 ] ]
		gives: '{"1": 1}'! !
